<?php
//the brand new pear package
if( !include_once( 'Gtk/FileDrop.php')) {
    MessageBox( 'To enable Drag\'n\'Drop of files, you should install' . "\n" . 'the Gtk_FileDrop PEAR package', 'Enhancement', MB_ICONINFORMATION);
}

/**
*   Preferences dialog for the PHP-Gtk manual browser
*   @author Christian Weiske
*/
class dlgPreferences
{
    var $arWidgets          = array();
    var $dlgPreferences     = null;
    var $glDlgPreferences   = null;
    
    /**
    *   If the settings shall be saves (user clicked ok)
    *   will be returned to the calling function when
    *   the main loop has quit
    *   @var boolean
    */
    var $bSaveSettings      = false;
    
    /**
    *   List with arrays (pixmap/pixmask) of loaded icons "ok" and "no"
    *   @var array
    */
    var $arIcons            = array();
    
    /**
    *   The manual language - needed for updates.
    *   @var string
    */
    var $strLanguage        = 'en';
    
    /**
    *   The location of the manual update file
    *   @var string
    */
    var $strXsaUrl          = 'http://www.cweiske.de/phpgtk_manualbrowser.xsa';
    
    /**
    *   The UpdateChecker object
    *   @var UpdateChecker
    */
    var $objChecker         = null;
    
    /**
    *   Where the programs directory could be located
    *   I know it is possible to read the program dir via the
    *    HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\ProgramFilesDir
    *   registry key, but that would require the use of the win32api functions
    *   which I don't want to rely on now
    *   @var array
    */
    var $arProgramDirs      = array( 'C:\\Programs', 'C:\\Program Files', 'C:\\Programme',
                                    'C:\\Programs\\Internet', 'C:\\Program Files\\Internet', 'C:\\Programme\\Internet',
                                    'C:\\Programs\\Internet\\Browser', 'C:\\Program Files\\Internet\\Browser', 'C:\\Programme\\Internet\\Browser',
                                    );
    
    /**
    *   If the loading of the icons had no errors
    *   @var boolean
    */
    var $bIconsLoadingOk    = false;
    
    /**
    *   DON'T USE THE CONSTRUCTOR FOR THIS!
    *   references in the constructor don't really work as expected sometimes
    */
    function initDialog()
    {
        strstr( PHP_OS, 'WIN') ? $this->strPathSeparator = '\\' : $this->strPathSeparator = '/';
        $this->buildDialog();
    }//function initDialog()
    

    
    /**
    *   shows the dialog and runs the gtk main loop
    *   should be called by the main program after
    *   instantiating the class and setting the current settings
    *
    *   @return boolean If the settings shall be taken
    */
    function display()
    {
        $this->dlgPreferences->show();
        gtk::main();
        return $this->bSaveSettings;
    }//function display()
    
        
    
    /**
    *   creates the dialog, connects the signals
    */
    function buildDialog()
    {
        $this->glDlgPreferences = &new GladeXML( dirname( __FILE__) . $this->strPathSeparator . "ManualBrowser.glade", 'dlgPreferences');

        $this->dlgPreferences   = $this->glDlgPreferences->get_widget( "dlgPreferences");
        $this->dlgPreferences   ->connect(	"destroy"		, array( &$this, "onDestroy"));
        $this->dlgPreferences   ->connect(	"delete-event"	, array( &$this, "onDelete"));
    
        $this->getWidgets( array( 
                           'ntbkMain','btnOk', 'btnCancel',
                           'txtLocationManual','txtLocationToc','txtLocationIndex','txtLocationSearchindex',
                           'pxmLocationManual','pxmLocationToc','pxmLocationIndex','pxmLocationSearchindex',
                           'btnUpdateToc','btnUpdateIndex','btnUpdateSearchindex','btnUpdateAll',
                           'txtBrowserOpera','txtBrowserFirefox','txtBrowserMozilla',
                           'btnFindOpera','btnFindFirefox','btnFindMozilla','btnFindAll',
                           ) );
        
        $this->connect_object( 'btnOk'      , 'clicked', 'onQuit', true);
        $this->connect_object( 'btnCancel'  , 'clicked', 'onQuit', false);
    
        $this->connect_object( 'btnUpdateToc'        , 'clicked', 'getUpdate', 'toc');
        $this->connect_object( 'btnUpdateIndex'      , 'clicked', 'getUpdate', 'index');
        $this->connect_object( 'btnUpdateSearchindex', 'clicked', 'getUpdate', 'searchindex');
        $this->connect_object( 'btnUpdateAll'        , 'clicked', 'getUpdates', array('toc','index','searchindex'));

        $this->connect_object( 'btnFindFirefox' , 'clicked', 'findBrowserLocation', 'firefox');
        $this->connect_object( 'btnFindMozilla' , 'clicked', 'findBrowserLocation', 'mozilla');
        $this->connect_object( 'btnFindOpera'   , 'clicked', 'findBrowserLocation', 'opera');
        $this->connect_object( 'btnFindAll'     , 'clicked', 'findBrowserLocations', array('firefox','mozilla','opera'));
        
        
        $this->dlgPreferences->realize();//needed for loadIcons()
        $this->loadIcons();
                
        $this->connect_object( 'txtLocationManual'       , 'changed', 'checkSettings', 'Manual');
        $this->connect_object( 'txtLocationToc'          , 'changed', 'checkSettings', 'Toc');
        $this->connect_object( 'txtLocationIndex'        , 'changed', 'checkSettings', 'Index');
        $this->connect_object( 'txtLocationSearchindex'  , 'changed', 'checkSettings', 'Searchindex');
        
        if( class_exists( 'Gtk_FileDrop')) {
            Gtk_FileDrop::attachDirectory( $this->arWidgets['txtLocationManual']);
            Gtk_FileDrop::attach( $this->arWidgets['txtLocationToc'], array('.dat'));
            Gtk_FileDrop::attach( $this->arWidgets['txtLocationIndex'], array('.dat'));
            Gtk_FileDrop::attach( $this->arWidgets['txtLocationSearchindex'], array('.dat'));
        }
        
        $this->arWidgets['ntbkMain']->set_page(1);
    }//function buildDialog()

    
    
    /**
    *   loads many widgets in the widget array
    */    
    function getWidgets( $arWidgets)
    {
        foreach( $arWidgets as $strWidget)
        {
            $this->arWidgets[$strWidget] = $this->glDlgPreferences->get_widget( $strWidget);
        }
    }//function getWidgets( $arWidgets)
    
    
    
    /**
    *   shorthand for the connect call
    */
    function connect( $strWidget, $strSignal, $strFunction, $objParam = null)
    {
        if( $objParam == null) {
            $this->arWidgets[$strWidget]->connect( $strSignal, array( &$this, $strFunction)); 
        } else {
            $this->arWidgets[$strWidget]->connect( $strSignal, array( &$this, $strFunction), $objParam); 
        }
    }//function connect( $strWidget, $strSignal, $strFunction)


    
    /**
    *   shorthand for the connect call
    */
    function connect_object( $strWidget, $strSignal, $strFunction, $objParam = null)
    {
        if( $objParam == null) {
            $this->arWidgets[$strWidget]->connect_object( $strSignal, array( &$this, $strFunction)); 
        } else {
            $this->arWidgets[$strWidget]->connect_object( $strSignal, array( &$this, $strFunction), $objParam); 
        }
    }//function connect_object( $strWidget, $strSignal, $strFunction)


    
    /**
    *	If the dialog is being destroyed, the loop should end
    *	Place the SaveSettings calls and so here
    */
    function onDestroy()
    {
        gtk::main_quit();
    }//function onDestroy()
    
    
    
    /**
    *	Call this function if you want to quit by hand
    *   @param  boolean If the settings shall be saved
    */
    function onQuit( $bSave = false)
    {
        if( $bSave) {
            if( !$this->allowQuitting()) {
                //don't destroy
                return;
            } else {
                //save settings, then quit
                $this->bSaveSettings    = true;
            }
        } else {
            //don't save
            $this->bSaveSettings    = false;
        }
        $this->dlgPreferences->destroy();
    }//function onQuit( $bSave)
    
    
    
    /**
    *	This function is called if you click the "x" in the upper right of the window
    *	The question is: Do you want to keep the window?
    *	if you return false, the app is closed
    *	if you return true, the app keeps on working
    */
    function onDelete()
    {
        return false;
    }//function onDelete()
    
    
    
    /**
    *   Checks if the user may close the dialog
    *   @return boolean True if all is ok, false if something is missing
    */
    function allowQuitting()
    {
        $this->collectSettings();
        
        //validate the settings
        if( !file_exists( $this->arSettings['directory'])) {
            MessageBox( 'The manual directory does not exist!' . "\n" . 'Please correct this', 'Preferences', MB_ICONERROR);
            return false;
        }
        if( !file_exists( $this->arSettings['toc-serialized'])) {
            MessageBox( 'The table of contents file does not exist!' . "\n" . 'Please correct this', 'Preferences', MB_ICONERROR);
            return false;
        }
        if( !file_exists( $this->arSettings['index-serialized'])) {
            MessageBox( 'The index file does not exist!' . "\n" . 'Please correct this', 'Preferences', MB_ICONERROR);
            return false;
        }
        if( !file_exists( $this->arSettings['index-search'])) {
            MessageBox( 'The search index file does not exist!' . "\n" . 'Please correct this', 'Preferences', MB_ICONERROR);
            return false;
        }
        return true;
    }//function allowQuitting()
    
    
    
    /**
    *   loads the icons (ok/no)
    */
    function loadIcons()
    {
        $bOk    = true;
        foreach( array( 'ok','no') as $strName)
        {
            $strFile    = dirname( __FILE__) . '/pixmaps/' . $strName . '.xpm';
            if( file_exists( $strFile)) {
                $this->arIcons[$strName]    = gdk::pixmap_create_from_xpm( $this->dlgPreferences->window, null, $strFile);
            } else {
                $bOk = false;
            }
        }
        $this->bIconsLoadingOk = $bOk;
    }//function loadIcons()
    
    
    
    /**
    *   Allows the calling program to set the settings
    *   in the text fields an so
    *   @param  array   The settings to display
    */
    function setSettings( $arSettings)
    {
        $arUnknownSettings  = array();
        foreach( $arSettings as $strId => $strValue)
        {
            switch( $strId) {
            case 'path.opera'      :  $this->arWidgets['txtBrowserOpera']       ->set_text( $strValue); break;
            case 'path.firefox'    :  $this->arWidgets['txtBrowserFirefox']     ->set_text( $strValue); break;
            case 'path.mozilla'    :  $this->arWidgets['txtBrowserMozilla']     ->set_text( $strValue); break;
            
            case 'directory'       :  $this->arWidgets['txtLocationManual']     ->set_text( $strValue); break;
            case 'toc-serialized'  :  $this->arWidgets['txtLocationToc']        ->set_text( $strValue); break;
            case 'index-serialized':  $this->arWidgets['txtLocationIndex']      ->set_text( $strValue); break;
            case 'index-search'    :  $this->arWidgets['txtLocationSearchindex']->set_text( $strValue); break;
            
            default:
                $arUnknownSettings[] = $strId;
                break;
            }
        }
        
        $this->checkSettings();
        
        if( count( $arUnknownSettings) > 0) {
            //only interesting for development
//            MessageBox( 'The following settings are not supported:' . "\n- " . implode( "\n- ", $arUnknownSettings), 'Preferences', MB_ICONEXCLAMATION);
        }
        
        $nBrowsersFound = 0;
        foreach( array( 'opera', 'firefox', 'mozilla') as $strBrowser) {
            if( $arSettings['path.' . $strBrowser] === null) {
                $this->findBrowserLocation( $strBrowser) ? $nBrowsersFound++ : 0;
            }
        }
        if( $nBrowsersFound > 0) {
            MessageBox( 'The location of ' . $nBrowsersFound . ' browsers has been detected automatically.', 'Preferences', MB_ICONINFORMATION);
        }
    }//function setSettings( $arSettings)
    
    
    
    /**
    *   checks the field settings
    */
    function checkSettings( $strField = null)
    {
        if( $strField === null) {
            $arThings   = array( 'Manual', 'Toc', 'Index', 'Searchindex');
        } else {
            $arThings   = array( $strField);
        }
        
        //set the icons
        if( $this->bIconsLoadingOk) 
        {
            foreach( $arThings as $strName) 
            {
                $strFile    = $this->arWidgets['txtLocation' . $strName]->get_text();
                if( file_exists( $strFile) && ( ($strName == 'Manual' && is_dir( $strFile) && file_exists( $strFile . $this->strPathSeparator . 'index.html')) ||($strName != 'Manual' && !is_dir( $strFile)))) {
                    $this->arWidgets['pxmLocation' . $strName]->set( $this->arIcons['ok'][0], $this->arIcons['ok'][1]);
                } else {
                    $this->arWidgets['pxmLocation' . $strName]->set( $this->arIcons['no'][0], $this->arIcons['no'][1]);
                }
            }
        }
    }//function checkSettings( $strField = null)
    
    
    
    /**
    *   Collects all the new settings and saves them in the settings array
    */
    function collectSettings()
    {
        $this->arSettings   = array(
            'path.opera'      => $this->arWidgets['txtBrowserOpera']       ->get_text(),
            'path.firefox'    => $this->arWidgets['txtBrowserFirefox']     ->get_text(),
            'path.mozilla'    => $this->arWidgets['txtBrowserMozilla']     ->get_text(),
            
            'directory'       => $this->arWidgets['txtLocationManual']     ->get_text(),
            'toc-serialized'  => $this->arWidgets['txtLocationToc']        ->get_text(),
            'index-serialized'=> $this->arWidgets['txtLocationIndex']      ->get_text(),
            'index-search'    => $this->arWidgets['txtLocationSearchindex']->get_text()
        );
        
        if( substr( $this->arSettings['directory'], -1) != $this->strPathSeparator) {
            $this->arSettings['directory'] .= $this->strPathSeparator;
        }
    }//function collectSettings()
    
    
    
    /**
    *   returns the new settings to the calling program
    *   @return array   The new settings
    */
    function getSettings()
    {
        return $this->arSettings;
    }//function getSettings()
    
    
    
    /**
    *   tries to get many updates
    *   @param  array   Array with the types accepted in getUpdate
    */
    function getUpdates( $arTypes)
    {
        foreach( $arTypes as $strType) {
            $this->getUpdate( $strType);
        }
    }//function getUpdates( $arTypes)
    
    
    
    /**
    *   tries to get an update
    *   @param  string  A type like "toc", "index" or "searchindex"
    */
    function getUpdate( $strType)
    {
        ini_set( 'track_errors', 1);
        
        if( !include_once( 'UpdateChecker.inc')) {
            MessageBox( 'File "UpdateChecker.inc" not found.', 'Update', MB_ICONERROR);
            return;
        }
        
        $strTitle     = 'Update ' . ucfirst( $strType);
        $strProductId = $strType . '-' . $this->strLanguage;
        
        if( $this->objChecker === null) {
            $this->objChecker   = new UpdateChecker();
        }
        
        $strFile    = $this->arWidgets['txtLocation' . ucfirst( $strType)]->get_text();
        if( file_exists( $strFile)) {
            $strDate    = date( 'Y-m-d', filemtime( $strFile));
        } else {
            //long before now
            $strDate    = '2000-01-01';
        }
        
        $bUpdate    = $this->objChecker->isUpdateAvailable( $this->strXsaUrl, $strProductId, null, $strDate);
        
        if( !$bUpdate) 
        {   //no update available
            if( $this->objChecker->hadError()) {
                //error
                MessageBox( 'Error getting update information:' . "\n\n" . $this->objChecker->getLastError(), $strTitle, MB_ICONERROR);
            } else {
                //no error, just up2date
                MessageBox( 'No new version available', $strTitle, MB_ICONINFORMATION);
            }
            return;
        }
        
        $arInformation  = $this->objChecker->getUpdateInformation( $this->strXsaUrl, $strProductId);
        //ask the user what to do
        if( !isset( $arInformation['changes'])) { $arInformation['changes'] = 'no information'; }
        $nAnswer    = MessageBox( 'There is an update available:' . "\n" . 'Version ' . $arInformation['version'] . ', date: ' . $arInformation['last-release'] . "\n" . 'Size: ' . $arInformation['download-size'] . "\n" . 'Changes:' . "\n" . $arInformation['changes'] . "\n\n" . 'Do you want to update the file?', $strTitle, MB_ICONQUESTION + MB_YESNO);
        if( $nAnswer == IDNO) {
            return;
        }
        
        $strTmpFile     = 'tmp-' . $strType . '-' . $this->strLanguage . '.dat';
        $strUrl         = $arInformation['download-url'];
        
        $glDlg          = &new GladeXML( dirname( __FILE__) . $this->strPathSeparator . "ManualBrowser.glade", 'dlgLoadingUpdate');
        $dlgLoading     = $glDlg->get_widget( "dlgLoadingUpdate");
        $lblSize        = $glDlg->get_widget( 'lblSize');
        $lblSize->set_text( 'File size: ' . $arInformation['download-size']);
        $dlgLoading->show();

        $bCopyOk        = @copy( $strUrl, $strTmpFile);
        
        $dlgLoading->hide();
        
        if( !$bCopyOk) {
            MessageBox( 'Error downloading file' . "\n" . $strUrl . "\n\n" . str_replace( "\r", '', $php_errormsg), $strTitle, MB_ICONERROR);
            return;
        }
        
        //overwrite the current file with the downloaded one
        //backup old file
        if( file_exists( $strFile)) {
            rename( $strFile, $strFile . '.bak');
        }
        //copy the new file
        $bOk = rename( $strTmpFile, $strFile);
        if( !$bOk) {
            //error copying file
            MessageBox( 'Error copying the new file' . "\n  " . $strTmpFile . "\nto\n  " . $strFile . "\n\n" . $php_errormsg, $strTitle, MB_ICONERROR);
            return;
        }
        
        $this->checkSettings( ucfirst( $strType));
        
        MessageBox( 'Download complete', $strTitle, MB_ICONINFORMATION);
    }//function getUpdate( $strType)
    
    
    
    /**
    *   tries to find the location of multiple browsers
    *   @param  array   List of multiple browsers accepted by findLocation
    */
    function findBrowserLocations( $arBrowser)
    {
        foreach( $arBrowser as $strBrowser) {
            $this->findBrowserLocation( $strBrowser);
        }
    }//function findBrowserLocations( $arBrowser)
    
    
    
    /**
    *   tries to find the location of a browser
    *   sets the location into the corresponding text box.
    *
    *   @param  string  A browser: firefox, mozilla or opera (lowercase!)
    *   @return boolean If the application has been found
    */
    function findBrowserLocation( $strBrowser)
    {
        strstr( PHP_OS, 'WIN') ? $strOs = 'win' : $strOs = 'unix';
        
        switch( $strBrowser)
        {
            case 'firefox':
                if( $strOs == 'win') {
                    $strProgram     = 'firefox.exe';
                    $arDirs         = array( 'Mozilla Firefox', 'Firefox', 'Mozilla/Firefox');
                } else {
                    $strProgram     = 'firefox';
                    $arDirs         = array( '/usr/bin', '/usr/local/bin', '/opt/firefox', '/opt/mozilla firefox');
                }
                break;
                
            case 'mozilla':
                if( $strOs == 'win') {
                    $strProgram     = 'mozilla.exe';
                    $arDirs         = array( 'Mozilla');
                } else {
                    $strProgram     = 'mozilla';
                    $arDirs         = array( '/usr/bin', '/usr/local/bin', '/opt/mozilla', '/opt/mozilla');
                }
                break;
                
            case 'opera':
                if( $strOs == 'win') {
                    $strProgram     = 'Opera.exe';
                    $arDirs         = array( 'Opera', 'Opera 8', 'Opera8', 'Opera75', 'Opera 7.5', 'Opera7', 'Opera 7');
                } else {
                    $strProgram     = 'opera';
                    $arDirs         = array( '/usr/bin', '/usr/local/bin', '/opt/opera/bin');
                }
                break;
                
            //unknown option
            default:
                return false;
                break;
        }
        
        if( $strOs == 'win')
        {   //add the program directories
            $arDirsAppend = $arDirs;
            $arDirs       = array();
            foreach( $this->arProgramDirs as $strDir) {
                foreach( $arDirsAppend as $strDirAppend) {
                    $arDirs[]   = $strDir . '\\' . $strDirAppend;
                }
            }
        }//win: prepend program dirs
        
        //now connect the program file name with the directories
        foreach( $arDirs as $nId => $strDir) {
            $arDirs[$nId]   .= $this->strPathSeparator . $strProgram;
        }
        
        //and now... find it
        foreach( $arDirs as $strPath)
        {
            if( file_exists( $strPath) && !is_dir( $strPath)) {
                //we've got it
                $this->arWidgets['txtBrowser' . ucfirst( $strBrowser)]->set_text( $strPath);
                return true;
                break;
            }
        }
        
        return false;
    }//function findBrowserLocation( $strBrowser)
    
    
}//class dlgPreferences
?>