<?php
/**
*   PHP-Gtk manual browser dialog
*   which checks for updates
*/
require_once( 'Gtk_UpdateChecker.inc');
require_once( 'xml.inc');

class dlgUpdate
{
    /**
    *   The update checker widget object (not the widget, the class)
    */
    var $objChecker = null;
    
    /**
    *   is set automatically
    */
    var $strVersion     = null;
    var $strProductName = 'PHP-Gtk manual browser';
    var $strXsaUrl      = 'http://www.cweiske.de/software.xsa';
    var $strProductId   = 'manualbrowser';
    
    /**
    *   DON'T USE THE CONSTRUCTOR FOR THIS!
    *   references in the constructor don't really work
    */
    function initDialog( $strVersion)
    {
        strstr( PHP_OS, 'WIN') ? $this->strPathSeparator = '\\' : $this->strPathSeparator = '/';
        $this->strVersion   = $strVersion;
        $this->buildDialog();
    }//function initDialog( $strVersion)
    

    
    /**
    *   shows the dialog and runs the gtk main loop
    *   should be called by the main program after
    *   instantiating the class and setting the current settings
    *
    *   @return boolean If the settings shall be taken
    */
    function display()
    {
        $this->dlgUpdate->show();
        gtk::main();
    }//function display()
    
        
    
    /**
    *   creates the dialog, connects the signals
    */
    function buildDialog()
    {
        $this->glDlgUpdate = &new GladeXML( dirname( __FILE__) . $this->strPathSeparator . "ManualBrowser.glade", 'dlgUpdate');

        $this->dlgUpdate   = $this->glDlgUpdate->get_widget( "dlgUpdate");
        $this->dlgUpdate   ->connect(	"destroy"		, array( &$this, "onDestroy"));
        $this->dlgUpdate   ->connect(	"delete-event"	, array( &$this, "onDelete"));
    
        $this->objChecker   = new Gtk_UpdateChecker( $this->strProductName, $this->strXsaUrl, $this->strProductId, $this->strVersion, null);
        $this->objChecker->createInterface();
        $this->dlgUpdate->add( $this->objChecker->widget);
        
    }//function buildDialog()


    
    /**
    *	If the dialog is being destroyed, the loop should end
    *	Place the SaveSettings calls and so here
    */
    function onDestroy()
    {
        gtk::main_quit();
    }//function onDestroy()
    
    
    
    /**
    *	This function is called if you click the "x" in the upper right of the window
    *	The question is: Do you want to keep the window?
    *	if you return false, the app is closed
    *	if you return true, the app keeps on working
    */
    function onDelete()
    {
        return false;
    }//function onDelete()
    
    
    
}//class dlgUpdate
?>